/**
 * QtAwesome - use font-awesome (or other font icons) in your c++ / Qt Application
 *
 * Copyright 2013 - Reliable Bits Software by Blommers IT. All Rights Reserved.
 * Author Rick Blommers
 */

#ifndef QTAWESOME_H
#define QTAWESOME_H

#include <QIcon>
#include <QIconEngine>
#include <QPainter>
#include <QRect>
#include <QVariantMap>


/// A list of all icon-names with the codepoint (unicode-value) on the right
/// You can use the names on the page  http://fortawesome.github.io/Font-Awesome/design.html
enum class fa {
    glass 					=	0xf000,
    music 					=	0xf001,
    search 					=	0xf002,
    envelopeo 				=	0xf003,
    heart 					=	0xf004,
    star 					=	0xf005,
    staro 					=	0xf006,
    user 					=	0xf007,
    film 					=	0xf008,
    thlarge 				=	0xf009,
    th 						=	0xf00a,
    thlist 				=	0xf00b,
    check 					=	0xf00c,
    times 					=	0xf00d,
    searchplus 			=	0xf00e,
    searchminus 			=	0xf010,
    poweroff 				=	0xf011,
    signal 					=	0xf012,
    cog 					=	0xf013,
    trasho 				=	0xf014,
    home 					=	0xf015,
    fileo 					=	0xf016,
    clocko 				=	0xf017,
    road 					=	0xf018,
    download 				=	0xf019,
    arrowcircleodown 	=	0xf01a,
    arrowcircleoup 		=	0xf01b,
    inbox 					=	0xf01c,
    playcircleo 			=	0xf01d,
    repeat 					=	0xf01e,
    refresh 				=	0xf021,
    listalt 				=	0xf022,
    lock 					=	0xf023,
    flag 					=	0xf024,
    headphones 				=	0xf025,
    volumeoff 				=	0xf026,
    volumedown 			=	0xf027,
    volumeup 				=	0xf028,
    qrcode 					=	0xf029,
    barcode 				=	0xf02a,
    tag 					=	0xf02b,
    tags 					=	0xf02c,
    book 					=	0xf02d,
    bookmark 				=	0xf02e,
    print 					=	0xf02f,
    camera 					=	0xf030,
    font 					=	0xf031,
    bold 					=	0xf032,
    italic 					=	0xf033,
    textheight 			=	0xf034,
    textwidth 				=	0xf035,
    alignleft 				=	0xf036,
    aligncenter 			=	0xf037,
    alignright 			=	0xf038,
    alignjustify 			=	0xf039,
    list 					=	0xf03a,
    outdent 				=	0xf03b,
    indent 					=	0xf03c,
    videocamera 			=	0xf03d,
    pictureo 				=	0xf03e,
    pencil 					=	0xf040,
    mapmarker 				=	0xf041,
    adjust 					=	0xf042,
    tint 					=	0xf043,
    pencilsquareo 		=	0xf044,
    sharesquareo 			=	0xf045,
    checksquareo 			=	0xf046,
    arrows 					=	0xf047,
    stepbackward 			=	0xf048,
    fastbackward 			=	0xf049,
    backward 				=	0xf04a,
    play 					=	0xf04b,
    pause 					=	0xf04c,
    stop 					=	0xf04d,
    forward 				=	0xf04e,
    fastforward 			=	0xf050,
    stepforward 			=	0xf051,
    eject 					=	0xf052,
    chevronleft 			=	0xf053,
    chevronright 			=	0xf054,
    pluscircle 			=	0xf055,
    minuscircle 			=	0xf056,
    timescircle 			=	0xf057,
    checkcircle 			=	0xf058,
    questioncircle 		=	0xf059,
    infocircle 			=	0xf05a,
    crosshairs 				=	0xf05b,
    timescircleo 			=	0xf05c,
    checkcircleo 			=	0xf05d,
    ban 					=	0xf05e,
    arrowleft 				=	0xf060,
    arrowright 			=	0xf061,
    arrowup 				=	0xf062,
    arrowdown 				=	0xf063,
    share 					=	0xf064,
    expand 					=	0xf065,
    compress 				=	0xf066,
    plus 					=	0xf067,
    minus 					=	0xf068,
    asterisk 				=	0xf069,
    exclamationcircle 		=	0xf06a,
    gift 					=	0xf06b,
    leaf 					=	0xf06c,
    fire 					=	0xf06d,
    eye 					=	0xf06e,
    eyeslash 				=	0xf070,
    exclamationtriangle 	=	0xf071,
    plane 					=	0xf072,
    calendar 				=	0xf073,
    random 					=	0xf074,
    comment 				=	0xf075,
    magnet 					=	0xf076,
    chevronup 				=	0xf077,
    chevrondown 			=	0xf078,
    retweet 				=	0xf079,
    shoppingcart 			=	0xf07a,
    folder 					=	0xf07b,
    folderopen 			=	0xf07c,
    arrowsv 				=	0xf07d,
    arrowsh 				=	0xf07e,
    barcharto 			=	0xf080,
    twittersquare 			=	0xf081,
    facebooksquare 		=	0xf082,
    cameraretro 			=	0xf083,
    key 					=	0xf084,
    cogs 					=	0xf085,
    comments 				=	0xf086,
    thumbsoup 			=	0xf087,
    thumbsodown 			=	0xf088,
    starhalf 				=	0xf089,
    hearto 				=	0xf08a,
    signout 				=	0xf08b,
    linkedinsquare 		=	0xf08c,
    thumbtack 				=	0xf08d,
    externallink 			=	0xf08e,
    signin 				=	0xf090,
    trophy 					=	0xf091,
    githubsquare 			=	0xf092,
    upload 					=	0xf093,
    lemono 				=	0xf094,
    phone 					=	0xf095,
    squareo 				=	0xf096,
    bookmarko 				=	0xf097,
    phonesquare 			=	0xf098,
    twitter 				=	0xf099,
    facebook 				=	0xf09a,
    github 					=	0xf09b,
    unlock 					=	0xf09c,
    creditcard 			=	0xf09d,
    rss 					=	0xf09e,
    hddo 					=	0xf0a0,
    bullhorn 				=	0xf0a1,
    bell 					=	0xf0f3,
    certificate 			=	0xf0a3,
    handoright 			=	0xf0a4,
    handoleft 			=	0xf0a5,
    handoup 				=	0xf0a6,
    handodown 			=	0xf0a7,
    arrowcircleleft 		=	0xf0a8,
    arrowcircleright 		=	0xf0a9,
    arrowcircleup 		=	0xf0aa,
    arrowcircledown 		=	0xf0ab,
    globe 					=	0xf0ac,
    wrench 					=	0xf0ad,
    tasks 					=	0xf0ae,
    filter 					=	0xf0b0,
    briefcase 				=	0xf0b1,
    arrowsalt 				=	0xf0b2,
    users 					=	0xf0c0,
    link 					=	0xf0c1,
    cloud 					=	0xf0c2,
    flask 					=	0xf0c3,
    scissors 				=	0xf0c4,
    fileso 				=	0xf0c5,
    paperclip 				=	0xf0c6,
    floppyo 				=	0xf0c7,
    square 					=	0xf0c8,
    bars 					=	0xf0c9,
    listul 				=	0xf0ca,
    listol 				=	0xf0cb,
    strikethrough 			=	0xf0cc,
    underline 				=	0xf0cd,
    table 					=	0xf0ce,
    magic 					=	0xf0d0,
    truck 					=	0xf0d1,
    pinterest 				=	0xf0d2,
    pinterestsquare 		=	0xf0d3,
    googleplussquare 		=	0xf0d4,
    googleplus 			=	0xf0d5,
    money 					=	0xf0d6,
    caretdown 				=	0xf0d7,
    caretup 				=	0xf0d8,
    caretleft 				=	0xf0d9,
    caretright 			=	0xf0da,
    columns 				=	0xf0db,
    sort 					=	0xf0dc,
    sortasc 				=	0xf0dd,
    sortdesc 				=	0xf0de,
    envelope 				=	0xf0e0,
    linkedin 				=	0xf0e1,
    undo 					=	0xf0e2,
    gavel 					=	0xf0e3,
    tachometer 				=	0xf0e4,
    commento 				=	0xf0e5,
    commentso 				=	0xf0e6,
    bolt 					=	0xf0e7,
    sitemap 				=	0xf0e8,
    umbrella 				=	0xf0e9,
    clipboard 				=	0xf0ea,
    lightbulbo 			=	0xf0eb,
    exchange 				=	0xf0ec,
    clouddownload 			=	0xf0ed,
    cloudupload 			=	0xf0ee,
    usermd 				=	0xf0f0,
    stethoscope 			=	0xf0f1,
    suitcase 				=	0xf0f2,
    bello 					=	0xf0a2,
    coffee 					=	0xf0f4,
    cutlery 				=	0xf0f5,
    filetexto 			=	0xf0f6,
    buildingo 				=	0xf0f7,
    hospitalo 				=	0xf0f8,
    ambulance 				=	0xf0f9,
    medkit 					=	0xf0fa,
    fighterjet 			=	0xf0fb,
    beer 					=	0xf0fc,
    hsquare 				=	0xf0fd,
    plussquare 			=	0xf0fe,
    angledoubleleft 		=	0xf100,
    angledoubleright 		=	0xf101,
    angledoubleup 		=	0xf102,
    angledoubledown 		=	0xf103,
    angleleft 				=	0xf104,
    angleright 			=	0xf105,
    angleup 				=	0xf106,
    angledown 				=	0xf107,
    desktop 				=	0xf108,
    laptop 					=	0xf109,
    tablet 					=	0xf10a,
    mobile 					=	0xf10b,
    circleo 				=	0xf10c,
    quoteleft 				=	0xf10d,
    quoteright 			=	0xf10e,
    spinner 				=	0xf110,
    circle 					=	0xf111,
    reply 					=	0xf112,
    githubalt 				=	0xf113,
    foldero 				=	0xf114,
    folderopeno 			=	0xf115,
    smileo 				=	0xf118,
    frowno 				=	0xf119,
    meho 					=	0xf11a,
    gamepad 				=	0xf11b,
    keyboardo 				=	0xf11c,
    flago 					=	0xf11d,
    flagcheckered 			=	0xf11e,
    terminal 				=	0xf120,
    code 					=	0xf121,
    replyall 				=	0xf122,
    mailreplyall 			=	0xf122,
    starhalfo 			=	0xf123,
    locationarrow 			=	0xf124,
    crop 					=	0xf125,
    codefork 				=	0xf126,
    chainbroken 			=	0xf127,
    question 				=	0xf128,
    info 					=	0xf129,
    exclamation 			=	0xf12a,
    superscript 			=	0xf12b,
    subscript 				=	0xf12c,
    eraser 					=	0xf12d,
    puzzlepiece 			=	0xf12e,
    microphone 				=	0xf130,
    microphoneslash 		=	0xf131,
    shield 					=	0xf132,
    calendaro 				=	0xf133,
    fireextinguisher 		=	0xf134,
    rocket 					=	0xf135,
    maxcdn 					=	0xf136,
    chevroncircleleft 	=	0xf137,
    chevroncircleright 	=	0xf138,
    chevroncircleup 		=	0xf139,
    chevroncircledown 	=	0xf13a,
    html5 					=	0xf13b,
    css3 					=	0xf13c,
    anchor 					=	0xf13d,
    unlockalt 				=	0xf13e,
    bullseye 				=	0xf140,
    ellipsish 				=	0xf141,
    ellipsisv 				=	0xf142,
    rsssquare 				=	0xf143,
    playcircle 			=	0xf144,
    ticket 					=	0xf145,
    minussquare 			=	0xf146,
    minussquareo 			=	0xf147,
    levelup 				=	0xf148,
    leveldown 				=	0xf149,
    checksquare 			=	0xf14a,
    pencilsquare 			=	0xf14b,
    externallinksquare 	=	0xf14c,
    sharesquare 			=	0xf14d,
    compass 				=	0xf14e,
    caretsquareodown 	=	0xf150,
    caretsquareoup 		=	0xf151,
    caretsquareoright 	=	0xf152,
    eur 					=	0xf153,
    gbp 					=	0xf154,
    usd 					=	0xf155,
    inr 					=	0xf156,
    jpy 					=	0xf157,
    rub 					=	0xf158,
    krw 					=	0xf159,
    btc 					=	0xf15a,
    file 					=	0xf15b,
    filetext 				=	0xf15c,
    sortalphaasc 			=	0xf15d,
    sortalphadesc 		=	0xf15e,
    sortamountasc 		=	0xf160,
    sortamountdesc 		=	0xf161,
    sortnumericasc 		=	0xf162,
    sortnumericdesc 		=	0xf163,
    thumbsup 				=	0xf164,
    thumbsdown 			=	0xf165,
    youtubesquare 			=	0xf166,
    youtube 				=	0xf167,
    xing 					=	0xf168,
    xingsquare 			=	0xf169,
    youtubeplay 			=	0xf16a,
    dropbox 				=	0xf16b,
    stackoverflow 			=	0xf16c,
    instagram 				=	0xf16d,
    flickr 					=	0xf16e,
    adn 					=	0xf170,
    bitbucket 				=	0xf171,
    bitbucketsquare 		=	0xf172,
    tumblr 					=	0xf173,
    tumblrsquare 			=	0xf174,
    longarrowdown 		=	0xf175,
    longarrowup 			=	0xf176,
    longarrowleft 		=	0xf177,
    longarrowright 		=	0xf178,
    appleicon 				=	0xf179,
    windowsicon 			=	0xf17a,
    androidicon 			=	0xf17b,
    linuxicon 				=	0xf17c,
    dribbble 				=	0xf17d,
    skype 					=	0xf17e,
    foursquare 				=	0xf180,
    trello 					=	0xf181,
    female 					=	0xf182,
    male 					=	0xf183,
    gittip 					=	0xf184,
    suno 					=	0xf185,
    moono 					=	0xf186,
    archive 				=	0xf187,
    bug 					=	0xf188,
    vk 						=	0xf189,
    weibo 					=	0xf18a,
    renren 					=	0xf18b,
    pagelines 				=	0xf18c,
    stackexchange 			=	0xf18d,
    arrowcircleoright 	=	0xf18e,
    arrowcircleoleft 	=	0xf190,
    caretsquareoleft 	=	0xf191,
    dotcircleo 			=	0xf192,
    wheelchair 				=	0xf193,
    vimeosquare 			=	0xf194,
    tryicon 				=	0xf195,
    plussquareo 			=	0xf196


};


//---------------------------------------------------------------------------------------

class QtAwesomeIconPainter;

/// The main class for managing icons
/// This class requires a 2-phase construction. You must first create the class and then initialize it via an init* method
class QtAwesome : public QObject
{
Q_OBJECT

public:

    QtAwesome(QObject *parent = 0);
    virtual ~QtAwesome();

    void init( const QString& fontname );
    bool initFontAwesome();

    void addNamedCodepoint( const QString& name, fa codePoint );
    QHash<QString,fa> namedCodePoints() { return namedCodepoints_; }

    void setDefaultOption( const QString& name, const QVariant& value  );
    QVariant defaultOption( const QString& name );

    QIcon icon( fa character, const QVariantMap& options = QVariantMap() );
    QIcon icon( const QString& name, const QVariantMap& options = QVariantMap() );
    QIcon icon(QtAwesomeIconPainter* painter, const QVariantMap& optionMap = QVariantMap() );

    void give( const QString& name, QtAwesomeIconPainter* painter );

    QFont font( int size );

    /// Returns the font-name that is used as icon-map
    QString fontName() { return fontName_ ; }

private:
    QString fontName_;                                     ///< The font name used for this map
    QHash<QString,fa> namedCodepoints_;                   ///< A map with names mapped to code-points

    QHash<QString, QtAwesomeIconPainter*> painterMap_;     ///< A map of custom painters
    QVariantMap defaultOptions_;                           ///< The default icon options
    QtAwesomeIconPainter* fontIconPainter_;                ///< A special painter fo painting codepoints
};


//---------------------------------------------------------------------------------------


/// The QtAwesomeIconPainter is a specialized painter for painting icons
/// your can implement an iconpainter to create custom font-icon code
class QtAwesomeIconPainter
{
public:
    virtual ~QtAwesomeIconPainter() {}
    virtual void paint( QtAwesome* awesome, QPainter* painter, const QRect& rect, QIcon::Mode mode, QIcon::State state, const QVariantMap& options ) = 0;
};



#endif // QTAWESOME_H
